<?php

namespace App\Http\Controllers\Admin;

use App\Order;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class AdminOrderController extends Controller
{
    public function index()
    {
        $items = Order::orderBy('created_at', 'desc')->paginate(15);
        $title = "طلبات الزبائن ";
        return view('orders', compact('items', 'title'))->with(['controller' => $this]);
    }

    public function delete(Request $request)
    {
        if (!$request->id) {
            return 'معرف الرسالة غير صالح';
        }
        $item = Order::find($request->id);
        if ($item != null) {
            if ($item->delete()) {
                return "تمت عملية الحذف بنجاح";
            } else {
                return "حدث خطأ غير متوقع أثناء الحذف .. حاول في وقت آخر !";
            }
        } else {
            return " تحاول حذف عنصر غير موجود ..  !";
        }
    }

    public function show($id)
    {
        $item = Order::find($id);
        if (!$item) {
            return view('errors.404');
        }
        $title = "تفاصيل الطلب";
        return view('order', compact('item', 'title'))->with(['controller' => $this]);
    }

    public function map($lat, $lng)
    {
        return view('showOrderMap', compact('lat', 'lng'));
    }
}
