<?php

namespace App\Http\Controllers\Admin;

use App\Http\Requests\AdminStoreSubscriptionPlan;
use App\SubscriptionPlan;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class AdminSubscriptionPlanController extends Controller
{
    public function index()
    {
        $items = SubscriptionPlan::orderBy('created_at', 'desc')->paginate(15);
        $title = "خطط الإشتراك ";
        return view('subscriptionPlans', compact('items', 'title'))->with(['controller' => $this]);
    }

    public function store(AdminStoreSubscriptionPlan $request)
    {
        try {
            SubscriptionPlan::create($request->all());
            return back()->with('success', 'تم عملية الإضافة بنجاح..');
        } catch (\Exception $exception) {
            return back()->with('success', 'حدث خلل غير متوقع أثناء عملية الإضافة');
        }

    }

    public function show($id)
    {
        $item = SubscriptionPlan::find($id);
        if (!$item) {
            return view('errors.404');
        }
        $title = "بيانات خطة الإشتراك";
        return view('subscriptionPlan', compact('title', 'item'))->with(['controller' => $this]);
    }

    public function update(AdminStoreSubscriptionPlan $request, $id)
    {
        try {
            SubscriptionPlan::find($id)->update($request->all());
            return back()->with('success', 'تم عملية التحديث بنجاح..');
        } catch (\Exception $exception) {
            return back()->with('success', 'حدث خلل غير متوقع أثناء عملية تحديث البيانات');
        }
    }
}
