<?php

namespace App\Http\Controllers\Api;

use App\Order;
use App\OrderAdditionalService;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Validator;

class ApiOrderAdditionalServiceController extends Controller
{
    public function delete($id)
    {
        try {
            $user = Auth::guard('api')->user();
            if ($user->role != 3) {
                return response()->json($this->result(false, "هذه الخدمة فقط للعملاء ", -4));
            }
            $item = OrderAdditionalService::where('id', '=', $id)->first();
            if (!$item) {
                return response()->json($this->result(false, "تعذر الحصول على العنصر المراد حذفه", -3));
            }
            //check if order_cloth related to customer
            $order = Order::where('id', '=', $item->order_id)->where('customer_id', '=', $user->id)->first();
            if (!$order) {
                return response()->json($this->result(false, "تعذر الحصول على العنصر المراد حذفه", -3));
            }
            $item_with_status = Order::where('id', '=', $item->order_id)->where('customer_id', '=', $user->id)->where('status', '=', -1)->first();
            if (!$item_with_status) {
                return response()->json($this->result(false, "تعذر حذف عنصر من الطلب، فقط يمكنك حذف عنصر من الطلب الجديد", -3));
            }
            //check if order item is the last item, so order must removed at whole
            if ($order->orderAdditionalServices->count() == 1 and $order->OrderClothes->count() == 0) {
                if (!($order->delete())) {
                    return response()->json($this->result(false, "حدث خلل غير متوقع أثناء الإرسال، حاول في وقت آخر ", -2));
                }
                return response()->json($this->result(true, "تم حذف الطلب بنجاح", 2));
            } else {
                //minus item cost from order cost
                $item_cost = $item->laundryAdditionalPrice->washing * $item->count;
                if ($item->delete()) {
                    $order->cost = $order->cost - $item_cost;
                    $order->save();
                    $customer_id = $user->id;
                    $updated_order = Order::with(['laundry', 'laundry.profile', 'laundry.location', 'laundry.has_rate' => function ($q) use ($customer_id/*, $laundry_id*/) {
                        $q->where('user_id', '=', $customer_id)/*->where('laundry_id', '=', $laundry_id)*/
                        ;
                    }, 'customer', 'customer.profile', 'customer.location', 'OrderClothes', 'orderAdditionalServices', 'orderAdditionalServices'])->find($order->id);
                    return response()->json($this->resultWithVar(true, "تم حذف العنصر وتحديث الطلب بنجاح", 1, "order", $updated_order));
                } else {
                    return response()->json($this->result(false, "حدث خلل غير متوقع أثناء الإرسال، حاول في وقت آخر ", -2));
                }
            }
        } catch (\Exception $exception) {
            return response()->json($this->result(false, "حدث خلل غير متوقع أثناء الإرسال، حاول في وقت آخر ", -2));
        }
    }

    /*    public function update(Request $request, $id)
        {
            try {
                $user = Auth::guard('api')->user();
                if ($user->role != 3) {
                    return response()->json($this->result(false, "هذه الخدمة فقط للعملاء ", -4));
                }
                //request validation
                $validator = Validator::make($request->all(), [
                    'count' => ['required', 'numeric'],
                ]);
                if ($validator->fails()) {
                    return response()->json($this->resultWithVar(false, "يجب إدخال جميع البيانات بالشكل الصحيح", 0, "errors", $this->validatorErrorsToStringArray($validator)));
                }
                $item = OrderAdditionalService::where('id', '=', $id)->first();
                if (!$item) {
                    return response()->json($this->result(false, "تعذر الحصول على العنصر المراد تحديثه", -3));
                }
                //check if order_cloth related to customer
                $order = Order::where('id', '=', $item->order_id)->where('customer_id', '=', $user->id)->first();
                if (!$order) {
                    return response()->json($this->result(false, "تعذر الحصول على العنصر المراد تحديثه", -3));
                }
                $item_with_status = Order::where('id', '=', $item->order_id)->where('customer_id', '=', $user->id)->where('status', '=', -1)->first();
                if (!$item_with_status) {
                    return response()->json($this->result(false, "تعذر تحديث عنصر من الطلب، فقط يمكنك تحديث عنصر من الطلب الجديد", -3));
                }
                //minus item cost from order cost
                $current_item_cost_one_count = $item->laundryAdditionalPrice->washing;
                $current_item_cost = $current_item_cost_one_count * $item->count;
                $item->count = $request->count;
                if ($item->save()) {
                    $order->cost = $order->cost - $current_item_cost;
                    $order->save();
                    $order->cost = $order->cost + ($current_item_cost_one_count * $request->count);
                    $order->save();
                    $updated_order = Order::with(['laundry', 'customer', 'OrderClothes', 'orderAdditionalServices', 'orderAdditionalServices'])->find($order->id);
                    return response()->json($this->resultWithVar(true, "تم تحديث العنصر وتحديث الطلب بنجاح", 1, "order", $updated_order));
                } else {
                    return response()->json($this->result(false, "حدث خلل غير متوقع أثناء الإرسال، حاول في وقت آخر ", -2));
                }
            } catch (\Exception $exception) {
                return response()->json($this->result(false, "حدث خلل غير متوقع أثناء الإرسال، حاول في وقت آخر ", -2));
            }
        }*/
}
