<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class AdminInserUsertRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
                'name' => 'required|string',
                'phone' => ['required','numeric','unique:users','regex:/^(009665|9665|\+9665|05|5)(5|0|3|6|4|9|1|8|7)([0-9]{7})$/'],
                'password' => 'required|max:250|string|min:6|confirmed',
                'email' => 'required|max:250|email|string|unique:users_profiles',
                'address' => 'required|max:250|string',
                'role' => 'numeric|required|regex:/[1-3]/',
                'lat' => 'required|numeric',
                'long' => 'required|numeric',
        ];
    }
}
